VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "MathCards"
   ClientHeight    =   4845
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4845
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtAnswer 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   60
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   120
      TabIndex        =   3
      Top             =   2280
      Width           =   4455
   End
   Begin VB.CommandButton cmdAnswer 
      Caption         =   "Start"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   20.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   660
      Left            =   1440
      TabIndex        =   0
      Top             =   4080
      Width           =   1815
   End
   Begin VB.Label lblTryAgain 
      Alignment       =   2  'Center
      Caption         =   "Try again!"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Visible         =   0   'False
      Width           =   4455
   End
   Begin VB.Label lblQuestion 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   60
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   4455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const NUM_QUESTIONS As Integer = 10
Private Const MIN_NUMBER As Integer = 0
Private Const MAX_NUMBER As Integer = 10
Private Const MAX_GUESSES As Integer = 2
Private m_QuestionNumber As Integer
Private m_NumRight As Integer
Private m_NumWrong As Integer
Private m_NumGuesses As Integer
Private m_Answer As Integer

Private Sub cmdAnswer_Click()
    If m_QuestionNumber < 1 Then
        cmdAnswer.Caption = "Answer"
        m_QuestionNumber = 1
        m_NumRight = 0
        m_NumWrong = 0
        ShowQuestion
    Else
        CheckAnswer
    End If
End Sub


Private Sub Form_Load()
    Randomize
    m_QuestionNumber = 0
End Sub


' Display a new question.
' This version picks from two operators: + and -.
Private Sub ShowQuestion()
Const NUM_OPERATORS As Integer = 2
Dim num1 As Integer
Dim num2 As Integer
Dim op As String
Dim temp As Integer

    num1 = Int(MIN_NUMBER + Rnd * (MAX_NUMBER - MIN_NUMBER + 1))
    num2 = Int(MIN_NUMBER + Rnd * (MAX_NUMBER - MIN_NUMBER + 1))

    ' Pick the operator.
    Select Case Int(1 + Rnd * NUM_OPERATORS)
        Case 1 ' +
            op = "+"
            m_Answer = num1 + num2
        Case 2 ' -
            op = "-"
            If num1 < num2 Then
                temp = num1
                num1 = num2
                num2 = temp
            End If
            m_Answer = num1 - num2
    End Select

    lblQuestion.Caption = _
        Format$(num1) & " " & op & " " & _
        Format$(num2)
    m_NumGuesses = 0
    lblTryAgain.Visible = False

    Me.Caption = "MathCards " & _
        Format$(m_QuestionNumber) & _
        " of " & Format$(NUM_QUESTIONS)

    txtAnswer.Text = ""
    txtAnswer.SetFocus
End Sub


' Check the user's answer.
Private Sub CheckAnswer()
Dim guess As Integer
Dim results As String

    guess = Val(txtAnswer.Text)
    txtAnswer.Text = ""
    txtAnswer.SetFocus

    If Abs(guess - m_Answer) < 0.01 Then
        ' Right. Show another question.
        m_NumRight = m_NumRight + 1

        m_QuestionNumber = m_QuestionNumber + 1
        If m_QuestionNumber > NUM_QUESTIONS Then
            ' We're done.
            lblQuestion.Caption = ""
            txtAnswer.Text = ""
            results = _
                "Results:" & vbCrLf & _
                "    Right: " & m_NumRight & vbCrLf & _
                "    Wrong: " & m_NumWrong & vbCrLf & _
                "  % Right: " & _
                FormatPercent(m_NumRight / (m_NumRight + m_NumWrong))
            MsgBox results, vbInformation Or vbOKOnly, "Good Job!"

            cmdAnswer.Caption = "Start"
            m_QuestionNumber = 0
            Me.Caption = "MathCards"
        Else
            ' Show another question.
            ShowQuestion
        End If
    Else
        ' Wrong. Give the user another chance.
        m_NumWrong = m_NumWrong + 1
        m_NumGuesses = m_NumGuesses + 1
        If m_NumGuesses > MAX_GUESSES Then
            ' Show a new question.
            ShowQuestion
        Else
            ' Let the user try again.
            lblTryAgain.Visible = True
            Beep
        End If
    End If
End Sub

